
/* Blocksorter */

use(io).
use(channels).


/* One cell of the sorter */

cell(inp:var(chan(int)),out:var(chan(int))):expr(void)=(
  reg:var(int).
  ireg:var(int).
  blockdone:var(bool).
  
  forever (
    inp ? (reg:=?inp);              /* Read in the first value */
    repeat (
      inp ? (ireg:=?inp);
      wait_for(10);
      if (ireg=999)              /* Recognise end-of-block marker */
      then (
        out!reg;
        out!999;
        blockdone:=true
      ) else (
        if (ireg>reg)          /* Output greater of new and
                                         stored values */
        then (
          out!reg;
          reg:=ireg
        ) else (
          out!ireg
        );
        blockdone:=false
      )
    ) until (blockdone)
  )
).


C:var(chan(int)^9).          /* Channels between cells */
inp:var(chan(int)).          /* Input to sorter */
out:var(chan(int)).          /* Output from sorter */

inp_process:expr(void)=(

  send(i:val(int)):expr(void)=(
    print("Input:  ");
    if (i=999)
    then (
      print("End of block")
    ) else (
      print(i)
    );
    print('\n');
    inp!i;
    wait_for(5)
  ).

  i:var(int).

  forever (
    forseq i in 1 to 10 do (
      send(rand(100))      /* Send random numbers to input */
    );
    send(999)                /* Send end of block marker */
  )
).

out_process:expr(void)=(
  forever (
    out ? (
      print("Output: ");
      if (?out=999)
      then (
        print("End of block\n")
      ) else (
        print(?out);
        print('\n')
      );
      wait_for(5)
    )
  )
).

i:var(int).

(
  init_chan(inp,"Input");
  init_chan(out,"Output");
  forseq i in 0 to 8 do (
    init_chan(C[i],"C"@i2s(i))
  );

  (
    cell(inp,C[0]) |          /* Simulate ten cells concurrently */
    (forpar 8 do cell(C[forparnum],C[(forparnum+1)])) |
    cell(C[8],out) |
    inp_process |
    out_process
  )
)

