
use(io).

/* Functions to initialise an array of integers from values in a file */


/* This version requires that there is enough data in the file to fill
   every entry in the array */

init_array_from_file(v:var(int^(n:val(int))),fn:val(string)):expr(void)=(
  a:var(int).
  f:var(tfile).
  
  newstringvalparam(fn);
  f:=topenin(fn);
  forseq a in 0 to (n-1) do (
    v[a]:=freadint(f)
  );
  close(f);
  endstringvalparam(fn)
).


/* This version stops when it reaches end of file */

init_array_from_file_to_eof(v:var(int^(n:val(int))),
                            fn:val(string)):expr(void)=(
  a:var(int).
  f:var(tfile).
  
  newstringvalparam(fn);
  f:=topenin(fn);
  a:=0;
  while ((a<n) && (!eof(f))) do (
    v[a]:=freadint(f);
    a:=a+1
  );
  close(f);
  endstringvalparam(fn)
).


/* Try it out */

X:var(int^16).
i:var(int).

set_default_input_base(16);  /* file contains hex data */
init_array_from_file_to_eof(X,"foo.dat");
forseq i in 0 to 15 do (
  printhex(X[i]);
  print('\n')
)


